=== lib/CMakeLists.txt ===
############################################################
# The ISIS project
# 
# CMake configuration file for the lib subdir
#
# Author: Thomas Proeger <thomasproeger@googlemail.com>
# Date: Wed, 06 Apr 2011 12:51:43 +0200
# 
############################################################

add_subdirectory(Core)
add_subdirectory(ImageIO)
add_subdirectory(Adapter)
