=== debian/changelog ===
isis (0.4.7-1~nd11.04+1) natty; urgency=low

  * Backported for natty.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 17 Feb 2012 05:12:04 -0500

isis (0.4.7-1) UNRELEASED; urgency=low

  * Initial Debian packaging (Closes: #633677).

 -- Michael Hanke <mih@debian.org>  Thu, 16 Feb 2012 09:31:22 +0100

isis (0.4.6+git10-g7b6a946-1) UNRELEASED; urgency=low

  * add support for writing 24/48bit rgb, and for 16bit grayscale images as
    PNG
  * dicom plugin builds on WIN32
  * fix bug which caused Chunk::swapAlong to fail for non 8bit data
  * add support for reading 24/48bit rgb, and for 16bit grayscale images (PNG)

 -- Enrico Reimer <reimer@cbs.mpg.de>  Tue, 31 Jan 2012 14:40:42 +0100

isis (0.4.4gca0af59-0) UNRELEASED; urgency=low

  * add png grayscale reading support
  * add parameter scaling to Image::copyToMem()
  * fixed bugs

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Tue, 12 Jan  2012 17:03:00 +0200

isis (0.4.3g322ed3e-0) UNRELEASED; urgency=low

  * api changes in PropertyMap
  * fixed bug in nifti-sa-plugin

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Tue, 10 Jan  2012 14:12:00 +0200

isis (0.4.2g12c919d-1) UNRELEASED; urgency=low

  * fixed dependency bug in libisis-qt4-dev package

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Mon, 19 Dec  2011 12:12:00 +0200

isis (0.4.2g12c919d-0) UNRELEASED; urgency=low

  * add support for fsl color images
  * bug fixes

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Fri, 16 Dec  2011 14:28:00 +0200

isis (0.4.1ge179836-3) UNRELEASED; urgency=low

  * add isisio0-common package
  * all packages are EXACTLY dependet from 0.4.1

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Tue, 29 Nov 2011 14:28:00 +0200

isis (0.4.1ge179836-2) UNRELEASED; urgency=low

  * add missing install file for isisio0-raw

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Mon, 28 Nov 2011 14:48:00 +0200

isis (0.4.1ge179836-1) UNRELEASED; urgency=low

  * fixed dependencies for lenny package (libboost)  

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Mon, 28 Nov 2011 14:48:00 +0200

isis (0.4.1ge179836-0) UNRELEASED; urgency=low

  * add new nifti standalone plugins
  * add first version of isis python bridge

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Mon, 28 Nov 2011 14:48:00 +0200

isis (0.4.0g9140af9-0) UNRELEASED; urgency=low

  * add first version for python support
  * add support for dcmtk 3.6

  * let ValuePtr::getRawAddress() return boost::shared_ptr<void> instead of boost::weak_ptr<void>, was a bit overdesigned
  * fix typo in ValuePtr::copyFromMem and suppress some correct warnings in typePtrTest.cpp
  * tell the user the size of the image written 
  * add PropertyMap::find to search single keys in the property tree
  * remove a private constructor in ValuePtr which prevented copy-construction from Value (should not be necessary)
  * add FilePtr to handle memory mapped data 
  * use mmap64 instead of mmap and ftruncate64 instead of fallocate 
  * fix bug in MemChunk creation which caused the underlying ValuePtr to have a length of 0
  * get back Chunk::copySlice
  * fallocate seems not to work on ubuntu - replace by more generic ftruncate
  * add FilePtr::close to explicitely unmap and close the mapped file 
  * use FilePtr in io-plugins raw and tar-proxy 
  * make PropertyMap entries two dimensional to be able to store lists of properties (this is just the storage / not in the interface)
  * added basic matrix class to do some matrix-algebra on FixedVector 
  * PropertyValue(bool needed) removed - was in conflict with creation from value
  * add length check to Image::copyToMem 
  * add aplying operators *=,/=,+= and -= to FixedVector 
  * make ProgressFeedback in IOApplication and IOFactory shared_ptr to make them more robust against copying
  * add some code to handle two dimensional properties (e.g. set by propertyValueAt) when reIndex-ing Images
  * add stl-compatible begin/end to FixedVector 
  * fix bug which caused the result of FixedMatrix::getRow to have the wrong internal size and use iterators instead of pointers there
  * fix wrong warning about inserting chunks into existing image when splicing
  * fix dicom build on mac
  * workaround for apparently still/again broken dynamic_cast on MacOS Lion 
  * remove dedundant LLMap from util::Application
  * add optional parameter to FileFormat::getSuffixes to specify which IO is meant
  * dont use Acquisition Time if its not precise enough and be less strict with expected properties - helps with GE data
  * fix compiles with prehistoric boost versions (<=1.35) 
  * add DICOM/AcquisitionNumber as attribute to differ between images 
  * add qdefaultmessageprint class to qt4 adapter
  * add rdialect onlyfirst to vistaio. This is needed by the viewer to only load the first image in zmaps

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Thu, 10 Nov 2011 12:48:00 +0200

isis (0.3.4g5ae6013-0) UNRELEASED; urgency=low

   * Fixed bug in transformCoords

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Tue, 12 Jul 2011 12:48:00 +0200

isis (0.3.3gitg71597cb-1) UNRELEASED; urgency=low


   * isis core should be build without debug log

 -- ISIS Group (The friendly isis team) <gr_isis@cbs.mpg.de>  Thu, 23 Jun 2011 15:38:35 +0200

isis (0.3.3gitg71597cb-0) UNRELEASED; urgency=low

   * use int64_t instead of platform dependent size_t (or time_t) - fixes
     compile for gcc/mac
  
   * do the copying directly in copyChunksToVector - prevent warning about
     empty object creation
  
   * enabled CTest support. Added CoreUtils and DataStorage tests as CTest
     targets.
   

