=== debian/control ===
Source: isis
Section: science
Priority: extra
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: ISIS Group <gr_isis@cbs.mpg.de>
Uploaders: Enrico Reimer <reimer@cbs.mpg.de>, Michael Hanke <mih@debian.org>
Build-Depends: debhelper (>= 7.0.50~), doxygen, cmake, libbz2-dev,
 libmuparser-dev, libnifti-dev, libvia-dev (>= 2.0.0~), libboost-python-dev,
 liboil0.3-dev | liboil-dev, python-all-dev, libqt4-dev,
 libpng12-dev | libpng-dev, libtiff4-dev | libtiff-dev,
 libdcmtk2-dev | libdcmtk1-dev, libboost-iostreams-dev, libboost-filesystem-dev,
 libboost-system-dev, libboost-date-time-dev, help2man
Standards-Version: 3.9.2
Homepage: https://github.com/isis-group
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/isis.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/isis.git


Package: libisis-core0
Section: libs
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Recommends: libisis-ioplugins-common, libisis-ioplugins-dicom
Description: I/O framework for neuroimaging data
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.
 .
 This Package provides the core library needed by all applications that
 are build upon ISIS.


Package: libisis-ioplugins-common
Section: libs
Architecture: any
Depends: neurodebian-popularity-contest, libisis-core0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: data format plugins for the ISIS framework
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.
 .
 This package provides plugins for data in NIfTI, PNG, VISTA format,
 raw-data access, as well as plugins for gzip-compression and tar-archive
 support.

Package: libisis-ioplugins-dicom
Section: science
Architecture: any
Depends: neurodebian-popularity-contest, libisis-core0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: dicom io plugin for the ISIS framework
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.
 .
 This package provides a plugin to read data from dicom datasets.
 It reads single files, or whole directories (a DICOMDIR is not needed).

Package: libisis-core-dev
Section: libdevel
Architecture: all
Depends: neurodebian-popularity-contest, libisis-core0 (>= ${source:Version}),
 libisis-core0 (<< ${source:Version}.1~), ${misc:Depends}
Description: I/O framework for neuroimaging data
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.
 .
 This package provides headers and library to develop applications with ISIS.


Package: isis-utils
Section: science
Architecture: any
Depends: neurodebian-popularity-contest, libisis-core0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: utilities for the ISIS neuroimaging data I/O framework
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.
 .
 This package provides a number of utilities to process neuroimaging data. This
 includes a multi-format converter and tools to inspect image meta data.


Package: libisis-qt4-0
Section: libs
Conflicts: isis-qt4
Replaces: isis-qt4
Architecture: any
Depends: neurodebian-popularity-contest, libisis-core0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Qt4 bindings for ISIS data I/O framework
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.


Package: libisis-qt4-dev
Section: libdevel
Conflicts: isis-qt4-dev
Architecture: all
Depends: neurodebian-popularity-contest, libisis-qt4-0 (>= ${source:Version}),
 libisis-qt4-0 (<< ${source:Version}.1~), ${misc:Depends},
 libqt4-dev
Description: Qt4 bindings for ISIS data I/O framework (development headers)
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.


Package: python-isis
Section: python
Architecture: any
Conflicts: isis-python
Replaces: isis-python
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: Python bindings for ISIS data I/O framework (development headers)
 This framework aids access of and conversion between various established
 neuro-imaging data formats, like  Nifti, Analyze, DICOM and VISTA. ISIS
 is extensible with plugins to add support for additional data formats.
